'''input:  monomial of form [op1,op2...] where op1 is an operator.
The monomial is reduced from left to right with rules: move
creation operators to the left, set flag to 0 if there would
be double occupancy or if there is a creation operator in
the result of the reduction op1 op2 -> op12
The final result is a single operator.  

The operator is represented: op = [sgn,coef, adagger, a]'''
import sys

def reduce_2(reduced,op):
  a_old=reduced[3]
  sgn = reduced[0] * op[0]
  symbol = op[1]
  ad_new = op[2]
  a_new = op[3]
  for i in range(4):
    if a_old[i] =='1' :
      if ad_new[i] =='1' :     # contract
        for c in a_old[i+1:]:
          if c == '1':  
            sgn = - sgn
        for c in ad_new[:i]: 
          if c == '1': 
            sgn = -sgn
        ad_new = ad_new[:i]+'0'+ad_new[i+1:]
      elif a_new[i] == '0':
        for c in ad_new:
          if c == '1': 
            sgn = -sgn
        for c in a_new[:i]:
          if c == '1': 
            sgn = - sgn
        for c in a_old[i+1:]:
          if c == '1': 
            sgn = - sgn
        a_new = a_new[:i]+'1'+a_new[i+1:]
      else:
        return 0,[]
  if ad_new != '0000': return 0, []
  sym_new = reduced[1]+' '+symbol
  return 1,(sgn,sym_new,ad_new,a_new)
  
def reduce_all(monomial):
  flag = 1
  if len(monomial) == 1:
    if monomial[0][2] != '0000': 
      return 0, []
    return flag,monomial[0]
  while len(monomial) > 2 and flag == 1:
    op1= monomial[0]
    op2= monomial[1]
    flag,op12= reduce_2(op1,op2)
    monomial = [op12,]+monomial[2:]
  if flag == 0 :
    return 0,[]
  if len(monomial) == 2:
    flag, result = reduce_2(monomial[0],monomial[1])
    if flag == 1 and result[2] != '0000': 
      return 0, []
    return flag, result
  return 0, []
          

def mk_expr(facdic):
  factors = sys.argv[1:]
  print 'expression to be reduced', factors
  expression=[]
  for factor in factors:
     expression.append(facdic[factor])
  expt = tuple(expression)
  expr_list = (expt,)
  return expr_list


def dist_n(n,partial):
  part_new = []
  for expression in partial:
    prefactors = expression[:n]
    postfactors = expression[n+1:]
    factor = expression[n]
    for term in factor:
      if n == 0 :
        part_new.append(((term,),)+postfactors)
      elif n+1 == len(expression):
        part_new.append(prefactors+((term,),))
      else:
        part_new.append(prefactors+((term,),)+postfactors)
        
  return part_new
facdic = {}  
term1 = (1,'u0', '0000','0000')
term2 = (1,'v0', '1010','0000')
term3 = (1,'u0','0000','0000')
term4 = (-1,'v0', '0000','1010')
uv02=((1,'u0', '0000','0000'), (1,'v0', '1010','0000'))
uv02adj = ((1,'u0','0000','0000'),(-1,'v0', '0000','1010'))
facdic['uv02'] = uv02; facdic['uv02adj'] = uv02adj
uv13 = ((1,'u1', '0000','0000'),(1,'v1', '0101','0000'))
uv13adj = ((1,'u1', '0000','0000'),(-1,'v1', '0000','0101'))
facdic['uv13'] = uv13; facdic['uv13adj']=uv13adj
#uv02adj = (term3,term4)
b0=((1,'u0','0000','1000'),(-1,'v0','0010','0000'))
bd0=((1,'u0','1000','0000'),(-1,'v0','0000','0010'))
facdic['b0'] = b0; facdic['bd0'] = bd0
b2=((1,'u0','0000','0010'),(1,'v0','1000','0000'))
bd2=((1,'u0','0010','0000'),(1,'v0','0000','1000'))
facdic['b2'] = b2; facdic['bd2'] = bd2
b1=((1,'u1','0000','0100'),(-1,'v1','0001','0000'))
bd1=((1,'u1','0100','0000'),(-1,'v1','0000','0001'))
facdic['b1'] = b1; facdic['bd1'] = bd1
b3=((1,'u1','0000','0001'),(1,'v1','0100','0000'))
bd3=((1,'u1','0001','0000'),(1,'v1','0000','0100'))
facdic['bd3'] = bd3
facdic['b3'] = b3; facdic['bd3'] = bd3
hsp = ((-1,'e0','1000','1000'),(1,'e0','0100','0100'),(-1,'e0','0010','0010'),(1,'e0','0001','0001'))
facdic['hsp'] = hsp
vpair = ((1,'G','1010','0101'),(1,'G','0101','1010'))
facdic['vpair'] = vpair
facdic['H'] = ((-1,'e0','1000','1000'),(1,'e0','0100','0100'),(-1,'e0','0010','0010'),(1,'e0','0001','0001'),(1,'G','1010','0101'),(1,'G','0101','1010'))
unit = ((1, '', '0000','0000'),)
print 'available factors', facdic.keys()
express_list = mk_expr(facdic)
Nops = len(express_list[0])
partial = express_list
for k in range(Nops):
  partial = dist_n(k,partial)
  for exprs in partial[0]:
#    print exprs
     t1 = 0   
for item in partial:
  n1 = len(item)
  mono =[]
  for i in range(n1):
    mono.append(item[i][0])
#  print mono   
  reduced = reduce_all(mono)
  if reduced[0] == 1:
     print reduced[1]